function [idx,D,V] = runSpectral(L,K, fixed)

if nargin<3
    fixed = 0;
end

[U,S,~] = svd(L,'econ');
S = diag(S);
r = sum(S>1e-4*S(1));
U = U(:,1:r);S = S(1:r);
U = U*diag(sqrt(S));
U = normr(U);
L = (U*U').^4;

% spectral clustering
D = diag(1./sqrt(sum(L,2)));
L = D*L*D;
[U,~,~] = svd(L);
V = U(:,1:K);
V = D*V;

if fixed==1
    n = size(V,1);
    M = zeros(K,K,20);
    rand('state',123456789);
    for i=1:size(M,3)
        inds = false(n,1);
        while sum(inds)<K
            j = ceil(rand()*n);
            inds(j) = true;
        end
        M(:,:,i) = V(inds,:);
    end
    idx = kmeans(V,K,'emptyaction','singleton','start',M,'display','off');
else
    idx = kmeans(V,K,'emptyaction','singleton','display','off');
end

end

